"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.index-of.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.date.to-string.js");
require("core-js/modules/es.regexp.to-string.js");
require("core-js/modules/es.function.name.js");
require("core-js/modules/es.array.from.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.is-array.js");
require("core-js/modules/es.object.assign.js");
require("core-js/modules/es.function.bind.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _react = _interopRequireWildcard(require("react"));
var _BarView = _interopRequireDefault(require("./bars/BarView"));
var _getBarLines = _interopRequireDefault(require("./bars/getBarLines"));
var _ChordTexts = _interopRequireDefault(require("./chords/ChordTexts"));
var _utils = require("./chords/utils");
var _Endings = _interopRequireDefault(require("./Endings"));
var _Sections = _interopRequireDefault(require("./Sections"));
var _getTimeSignature = _interopRequireDefault(require("./getTimeSignature"));
var _SvgRenderer = _interopRequireDefault(require("./SvgRenderer"));
var _Selections = _interopRequireDefault(require("./Selections"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _excluded = ["startX"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var propTypes = {
  width: _propTypes["default"].number.isRequired,
  bars: _propTypes["default"].array.isRequired,
  BarMouseUp: _propTypes["default"].func,
  BarMouseDown: _propTypes["default"].func,
  BarMouseOver: _propTypes["default"].func,
  colorSelected: _propTypes["default"].string,
  colorActive: _propTypes["default"].string,
  activeBar: _propTypes["default"].number,
  selectedBars: _propTypes["default"].array
};
var SvgChordProgression = function SvgChordProgression(props) {
  var barView = new _BarView["default"]({
    width: props.width,
    barsPerLine: 4,
    sub: 10,
    sup: 10,
    margins: {
      top: 20,
      left: 20,
      line: 30,
      right: 20
    },
    bar: {
      padding: {
        top: 25,
        left: 8
      },
      height: 40,
      repetitionLineSpace: 4
    }
  });
  // logic in constructor: it won't be updated with a render caused by receiving new props,
  // has to be updated with a 'key' prop change,
  // this is done for performance reasons
  var bars = props.bars.map(function (bar) {
    return (0, _utils.transformChords)(bar);
  }).map(function (bar, i) {
    return barView.setDimensions(bar, i);
  });
  var svg = new _SvgRenderer["default"]();
  var scale = (0, _utils.getChordTextScale)(bars, barView.bar.width);
  var chordTexts = (0, _ChordTexts["default"])(scale);
  var _chordTexts$getSvgEle = chordTexts.getSvgElems(bars, barView),
    startX = _chordTexts$getSvgEle.startX,
    chordTextsSvgElems = _objectWithoutProperties(_chordTexts$getSvgEle, _excluded);
  svg.addObject(chordTextsSvgElems);
  svg.addObject((0, _Sections["default"])(bars, barView).getSections());
  svg.addObject((0, _getBarLines["default"])(bars, barView));
  svg.addObject((0, _Endings["default"])(bars, barView).getEndings());
  svg.addTexts((0, _getTimeSignature["default"])(bars, barView));
  var barsRender = function barsRender() {
    var emptyFn = function emptyFn() {};
    var colorSelected = props.colorSelected || "#00f";
    var selectedBars = props.selectedBars || [-1, -1];
    var colorActive = props.colorActive || "#f00";
    var activeBar = props.activeBar === undefined ? -1 : props.activeBar;
    var opacity = 0.4;
    var barMouseDown = props.barMouseDown || emptyFn;
    var barMouseOver = props.barMouseOver || emptyFn;
    var barMouseUp = props.barMouseUp || emptyFn;
    var barComponents = [],
      barProps,
      isSelected,
      isCursorBar;
    var _iterator = _createForOfIteratorHelper(bars.entries()),
      _step;
    try {
      var _loop = function _loop() {
        var _step$value = _slicedToArray(_step.value, 2),
          i = _step$value[0],
          bar = _step$value[1];
        isSelected = i >= selectedBars[0] && i <= selectedBars[1];
        isCursorBar = i === activeBar;
        barProps = {
          width: barView.bar.width,
          height: barView.bar.height,
          fill: isCursorBar ? colorActive : isSelected ? colorSelected : "#fff",
          fillOpacity: isSelected || isCursorBar ? opacity : 0,
          strokeOpacity: 0,
          onMouseDown: function onMouseDown(e) {
            e.preventDefault();
            barMouseDown(i);
          },
          onMouseOver: function onMouseOver(e) {
            e.preventDefault();
            barMouseOver(i);
          },
          onMouseUp: function onMouseUp(e) {
            e.preventDefault();
            barMouseUp(i);
          }
        };
        barComponents.push(_objectSpread(_objectSpread({}, bar.dimensions), barProps));
      };
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        _loop();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return barComponents.map(function (props, i) {
      return /*#__PURE__*/_react["default"].createElement("rect", _extends({
        key: "bar".concat(i)
      }, props));
    });
  };
  var selectionsRender = function selectionsRender(selections) {
    if (!selections || !selections.length) return;
    var rects = _Selections["default"].getRects(bars, barView, startX, selections);
    return rects.map(function (props, i) {
      return /*#__PURE__*/_react["default"].createElement("rect", _extends({
        key: i
      }, props));
    });
  };
  return /*#__PURE__*/_react["default"].createElement("svg", {
    width: props.width,
    height: barView.getHeight(bars.length)
  }, svg.render(), barsRender(), selectionsRender(props.selections));
};
var ChordProgression = function ChordProgression(props) {
  var ref = (0, _react.useRef)(null);
  var _useState = (0, _react.useState)(0),
    _useState2 = _slicedToArray(_useState, 2),
    width = _useState2[0],
    setWidth = _useState2[1];
  (0, _react.useEffect)(function () {
    if (!ref.current || !ref.current.getBoundingClientRect().width) {
      console.warn("width of wrapping div is 0 so nothing will be drawn");
      return;
    }
    setWidth(ref.current.getBoundingClientRect().width);
  }, [ref.current]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: ref
  }, /*#__PURE__*/_react["default"].createElement(SvgChordProgression, _extends({
    width: width
  }, props)));
};
var _default = ChordProgression;
exports["default"] = _default;